// Inventory shop handler.
class DSHandler expands DHandler
	config(DCoopItemShop);

struct PItem
{
var() config int Price;
var() config string Item;
};

var() config bool bUseDamagePoints;
var() config bool bUseScoreMoney;
var() config PItem DPItems[512];
var() config PItem SCItems[512];

function ItemList(DPlayer PP)
{
	local int I;
	for (I=0;I<512;I++)
	{
	if (SCItems[I].Item!="") if (SCItems[I].Price>0)
	PP.RecvMsg(DCPri,"[S-"$(I+1)$"]: "$SCItems[I].Item$" ("$SCItems[I].Price$" Score Points)",'Console');
	if (DPItems[I].Item!="") if (DPItems[I].Price>0)
	PP.RecvMsg(DCPri,"[D-"$(I+1)$"]: "$DPItems[I].Item$" ("$DPItems[I].Price$" Damage Points)",'Console');
	}
}

function BuyItemSc(DPlayer PP, int I)
{
	local class<Inventory> ICl;
	local bool bS;
	I--;
	if (!bUseScoreMoney) {PP.ClientMessage("Purchasing items using score points (SP) is not allowed.",'Error'); return;}
	if (I<0) return; if (I>511) return;
	if (SCItems[I].Item=="") {PP.ClientMessage("Invalid pick. [Item not defined]",'Error'); return;}
	ICl=class<Inventory>(DynamicLoadObject(DPItems[I].Item,class'Class'));
	if (ICl==None) {PP.ClientMessage("Invalid pick. [Class load failure]",'Error'); return;}
	if (int(PP.myPRI.Score) < SCItems[I].Price) {PP.ClientMessage("You have only "$int(PP.myPRI.Score)$" Score Points, the item costs "$SCItems[I].Price$".",'Error'); return;}
	PP.myPRI.Score-=float(SCItems[I].Price);
	bS=GiveItem(PP,ICl);
	if (!bS)
	{
	PP.myPRI.Score+=float(SCItems[I].Price);
	PP.ClientMessage("Invalid pick. [Item spawn failure]",'Error');
	return;
	}
	PP.ClientMessage("Successfully bought "$ICl$" for "$SCItems[I].Price$" SP, "$int(PP.myPRI.Score)$" SP remain.",'ServerEvent');
}

function BuyItemDp(DPlayer PP, int I)
{
	local class<Inventory> ICl;
	local bool bS;
	I--;
	if (!bUseDamagePoints) {PP.ClientMessage("Purchasing items using damage points (DP) is not allowed.",'Error'); return;}
	if (I<0) return; if (I>511) return;
	if (DPItems[I].Item=="") {PP.ClientMessage("Invalid pick. [Item not defined]",'Error'); return;}
	ICl=class<Inventory>(DynamicLoadObject(DPItems[I].Item,class'Class'));
	if (ICl==None) {PP.ClientMessage("Invalid pick. [Class load failure]",'Error'); return;}
	if (PP.myPRI.DmgPts < DPItems[I].Price) {PP.ClientMessage("You have only "$PP.myPRI.DmgPts$" Damage Points, the item costs "$DPItems[I].Price$".",'Error'); return;}
	PP.myPRI.DmgPts-=DPItems[I].Price;
	bS=GiveItem(PP,ICl);
	if (!bS)
	{
	PP.myPRI.DmgPts+=DPItems[I].Price;
	PP.ClientMessage("Invalid pick. [Item spawn failure]",'Error');
	return;	
	}
	PP.ClientMessage("Successfully bought "$ICl$"for "$DPItems[I].Price$" DP, "$PP.myPRI.DmgPts$" DP remain.",'ServerEvent');
}

function bool GiveItem( Pawn PP, class<Inventory> IClass )
{
	local inventory Inv;
	local int I;
	local bool bCWP, bCW;

	if (PP.IsA('DPlayer'))
	DPlayer(PP).bDontRecvPickup=True;
	
	bCWP=IClass.Default.bCollideWhenPlacing;
	bCW=IClass.default.bCollideWorld;
	
	IClass.Default.bCollideWhenPlacing = False;
	IClass.Default.bCollideWorld = False;
	
	Inv = Spawn( IClass,PP,'',PP.Location,PP.Rotation );

	IClass.Default.bCollideWhenPlacing = bCWP;
	IClass.Default.bCollideWorld = bCW;
	
	if( Inv==None )
		{ if (PP.IsA('DPlayer')) DPlayer(PP).bDontRecvPickup=False; return false; }
		/* That sucks. */

	Inv.SetCollision(False,False,False);
	Inv.PickupMessage=""; Inv.PickupSound=None;
	Inv.bHeldItem=True;	Inv.Touch(PP);
	Inv.PickupMessage=Inv.Default.PickupMessage;
	Inv.PickupSound=Inv.Default.PickupSound;
	
	If( Inv.GetStateName() == 'Sleeping' || Inv.GetStateName() == 'Pickup' ||
		Inv.GetStateName()==Inv.InitialState 								  )
		Inv.Destroy();
		
	if (PP.IsA('DPlayer'))
	DPlayer(PP).bDontRecvPickup=False;
	
	return true;
}

defaultproperties
{
				bUseDamagePoints=True
				bUseScoreMoney=True
}
